<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Электронный банк</title>
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/mini.css/3.0.1/mini-default.min.css">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <script src="common.js"></script>
</head>
<body>
<p class="welcome">iBank - твой электронный банк!
    <small id="version">
        v<span></span>
    </small>
</p>
<h1>
    Привет, <span id="username">...</span>!
</h1>
<p>
    На Вашем балансе <span id="balance">?</span> руб.
    <a onclick="logout()" href="javascript:;">Выход</a></p>
<form name="transfer" onsubmit="doTransfer();return false">
    <h1>🤑 Перевести деньги</h1>
    <fieldset>
        <input name="recipient" placeholder="Кому">
        <input name="amount" placeholder="Сумма">
    </fieldset>
    <button type="submit">Перевести</button>
</form>
<h1>Переводы от вас</h1>
<div id="outbox">
    <p>Загрузка...</p>
</div>
<h1>Переводы вам</h1>
<div id="inbox">
    <p>Загрузка...</p>
</div>
<style>
    .welcome small {
        border: 1px solid silver;
        padding: 2px 5px;
        border-radius: 5px;
    }
</style>
<script>
    var versionBlock = document.querySelector('#version');
    versionBlock.innerHTML = version;

    function loadMe() {
        var request = new XMLHttpRequest();
        console.log('GET /api/me');
        request.open('GET', '/api/me', true);
        processRequest(request, function (data) {
            document.getElementById('username').innerHTML = data.username;
            document.getElementById('balance').innerHTML = data.balance;
        }, function () {
            document.cookie = '';
            document.location = '/';
        });
        request.send();
    }

    function logout() {
        var request = new XMLHttpRequest();
        console.log('GET /api/logout');
        request.open('GET', '/api/logout', true);
        processRequest(request, function () {
            document.cookie = '';
            alert('Ваша сессия закрыта!');
            document.location = '/?v=' + version;
        });
        if (version === '1.0') {
            document.location = '/?v=' + version;
        } else {
            request.send();
        }
    }

    function doTransfer() {
        var recipientInput = document.querySelector('form[name=transfer] input[name=recipient]');
        var amountInput = document.querySelector('form[name=transfer] input[name=amount]');

        var data = {
            recipient: recipientInput.value,
            amount: amountInput.value
        };

        var request = new XMLHttpRequest();
        console.log('запрос на сервер POST /api/transfer', data);
        request.open('POST', '/api/transfer', true);
        processRequest(request, function (data) {
            console.log(data);
            loadOutbox();
            alert('деньги отправлены');
        });
        request.send(JSON.stringify(data));
    }

    function loadOutbox() {
        var outbox = document.getElementById('outbox')
        while (outbox.firstChild) {
            outbox.removeChild(outbox.lastChild);
        }

        var request = new XMLHttpRequest();
        console.log('запрос на сервер GET /api/me/outbox');
        request.open('GET', '/api/me/outbox', true);
        processRequest(request, function (data) {
            var table = document.createElement('table');
            var tr = document.createElement('tr');
            var td = document.createElement('td');
            td.innerHTML = 'Кому';
            tr.appendChild(td);
            td = document.createElement('td');
            td.innerHTML = 'Сумма';
            tr.appendChild(td);
            for (var transaction of data) {
                var {recipient, amount} = transaction;
                tr = document.createElement('tr');
                td = document.createElement('td');
                td.innerHTML = recipient;
                tr.appendChild(td);

                td = document.createElement('td');
                td.innerHTML = amount + ' Р.';
                tr.appendChild(td);

                table.appendChild(tr);
            }
            outbox.appendChild(table);
        });
        request.send();
    }

    function loadInbox() {
        var inbox = document.getElementById('inbox')
        while (inbox.firstChild) {
            inbox.removeChild(inbox.lastChild);
        }

        var request = new XMLHttpRequest();
        console.log('запрос на бекенд GET /api/me/inbox');
        request.open('GET', '/api/me/inbox', true);
        processRequest(request, function (data) {
            var table = document.createElement('table');
            for (var transaction of data) {
                var {sender, amount} = transaction;
                var tr = document.createElement('tr');
                var td = document.createElement('td');
                td.innerHTML = sender;
                tr.appendChild(td);

                td = document.createElement('td');
                td.innerHTML = amount;
                tr.appendChild(td);

                table.appendChild(tr);
            }
            inbox.appendChild(table);
        });
        request.send();
    }

    setTimeout(loadMe, 500);
    loadInbox();
    loadOutbox();

    console.log('фронтенд загружен');
</script>
</body>
</html>
